	#version 150

// DEFAULT_VERTEX_SHADER

in vec4 vert_position;
in vec3 vert_normal;
in vec3 vert_tangent;
in vec3 vert_bitangent;
in vec2 texCoord;
//in float tile_factor;
//in float depth_scale_factor;
uniform mat4 model_matrix;

layout(std140) uniform TransformationMatrices
{
    mat4 camera_matrix;
    mat4 persp_matrix;
};

out vec3 vert_normal_model;
out vec4 vert_position_model;
smooth out vec2 texture_coordinate;
out mat3 tangent_matrix;
out mat3 inv_tangent_matrix;
//out float tile_factor;
//out float depth_scale_factor;

void main()
{
    gl_Position = persp_matrix * camera_matrix * model_matrix * vert_position;
    
    vert_position_model = vert_position;
    vert_normal_model = vert_normal;
    //tile_factor = tile_factor;
    //depth_scale_factor = depth_scale_factor;
    texture_coordinate = texCoord;
    vec3 nt = normalize(vert_tangent);
    vec3 nb = normalize(vert_bitangent);
    vec3 nn = normalize(vert_normal);
    inv_tangent_matrix = mat3(	nt.x, nt.y, nt.z,
    							nb.x, nb.y, nb.z,
    							nn.x, nn.y, nn.z);//mat3(normalize(vert_tangent), normalize(vert_bitangent), normalize(vert_normal);
    tangent_matrix = transpose(inv_tangent_matrix);
}