#version 150

// Input vertex data, different for all executions of this shader.
in vec4 vert_position;
in vec3 vert_normal;

smooth out vec4 interpColor;

//uniform vec3 light_position;
//uniform vec4 light_intensity;
//uniform vec4 ambient_intensity;

uniform mat4 camera_matrix;
uniform mat4 persp_matrix;
uniform mat4 model_matrix;

void main(){

	vec4 light_position = vec4(-1.0f, 3.0f, 2.0f,1.0f);
	vec4 light_intensity = vec4(1.0f, 0.5f, 1.0f, 1.0f);

	mat4 modelToCameraMatrix = camera_matrix * model_matrix;

	vec4 camera_position = modelToCameraMatrix * vert_position;
	
	gl_Position =  persp_matrix * camera_position;
	
	light_position = camera_matrix * light_position;
	
	vec4 normal_cameraSpace = normalize(modelToCameraMatrix * vec4(vert_normal, 0.0f));
	
	vec3 direction_to_light = normalize(vec3(light_position) -  vec3(camera_position));
	
	float cosAngIncidence = dot(vec3(normal_cameraSpace), direction_to_light);
	cosAngIncidence = clamp(cosAngIncidence, 0, 1);
	
	interpColor = light_intensity * cosAngIncidence; //TODO + Ambientlight
	//interpColor = vec4(1.0f, 0.0f, 0.0, 1.0f);

}
